diff -ruN vdr-1.5.14/themes.c vdr-1.5.15/themes.c
--- vdr-1.5.14/themes.c	2007-08-05 16:11:35.000000000 +0200
+++ vdr-1.5.15/themes.c	2008-02-10 17:25:00.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: themes.c 1.7 2007/08/05 14:11:35 kls Exp $
+ * $Id: themes.c 1.8 2008/02/10 16:25:00 kls Exp $
  */
 
 #include "themes.h"
@@ -285,18 +285,14 @@
 
 void cThemes::Load(const char *SkinName, const char *ThemeName, cTheme *Theme)
 {
-  char *FileName = NULL;
-  asprintf(&FileName, "%s/%s-%s.theme", themesDirectory, SkinName, ThemeName);
+  cString FileName = cString::sprintf("%s/%s-%s.theme", themesDirectory, SkinName, ThemeName);
   if (access(FileName, F_OK) == 0) // the file exists
      Theme->Load(FileName);
-  free(FileName);
 }
 
 void cThemes::Save(const char *SkinName, cTheme *Theme)
 {
-  char *FileName = NULL;
-  asprintf(&FileName, "%s/%s-%s.theme", themesDirectory, SkinName, Theme->Name());
+  cString FileName = cString::sprintf("%s/%s-%s.theme", themesDirectory, SkinName, Theme->Name());
   if (access(FileName, F_OK) != 0) // the file does not exist
      Theme->Save(FileName);
-  free(FileName);
 }
diff -ruN vdr-1.5.14/thread.c vdr-1.5.15/thread.c
--- vdr-1.5.14/thread.c	2007-10-19 16:30:13.000000000 +0200
+++ vdr-1.5.15/thread.c	2008-02-15 15:17:42.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 1.63 2007/10/19 14:30:13 kls Exp $
+ * $Id: thread.c 1.64 2008/02/15 14:17:42 kls Exp $
  */
 
 #include "thread.h"
@@ -231,7 +231,7 @@
   if (Description) {
      va_list ap;
      va_start(ap, Description);
-     vasprintf(&description, Description, ap);
+     description = strdup(cString::sprintf(Description, ap));
      va_end(ap);
      }
 }
diff -ruN vdr-1.5.14/timers.c vdr-1.5.15/timers.c
--- vdr-1.5.14/timers.c	2007-08-04 11:23:33.000000000 +0200
+++ vdr-1.5.15/timers.c	2008-02-16 15:47:40.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 1.68 2007/08/04 09:23:33 kls Exp $
+ * $Id: timers.c 1.73 2008/02/16 14:47:40 kls Exp $
  */
 
 #include "timers.h"
@@ -13,13 +13,17 @@
 #include "device.h"
 #include "i18n.h"
 #include "libsi/si.h"
+#include "recording.h"
 #include "remote.h"
+#include "status.h"
+
+#define VFAT_MAX_FILENAME 40 // same as MAX_SUBTITLE_LENGTH in recording.c
 
 // IMPORTANT NOTE: in the 'sscanf()' calls there is a blank after the '%d'
 // format characters in order to allow any number of blanks after a numeric
 // value!
 
-// -- cTimer -----------------------------------------------------------------
+// --- cTimer ----------------------------------------------------------------
 
 cTimer::cTimer(bool Instant, bool Pause, cChannel *Channel)
 {
@@ -99,13 +103,14 @@
 cTimer& cTimer::operator= (const cTimer &Timer)
 {
   if (&Timer != this) {
+     uint OldFlags = flags & tfRecording;
      startTime    = Timer.startTime;
      stopTime     = Timer.stopTime;
      lastSetEvent = 0;
      recording    = Timer.recording;
      pending      = Timer.pending;
      inVpsMargin  = Timer.inVpsMargin;
-     flags        = Timer.flags;
+     flags        = Timer.flags | OldFlags;
      channel      = Timer.channel;
      day          = Timer.day;
      weekdays     = Timer.weekdays;
@@ -132,20 +137,17 @@
   return r;
 }
 
-cString cTimer::ToText(bool UseChannelID)
+cString cTimer::ToText(bool UseChannelID) const
 {
-  char *buffer;
   strreplace(file, ':', '|');
-  asprintf(&buffer, "%u:%s:%s:%04d:%04d:%d:%d:%s:%s\n", flags, UseChannelID ? *Channel()->GetChannelID().ToString() : *itoa(Channel()->Number()), *PrintDay(day, weekdays, true), start, stop, priority, lifetime, file, aux ? aux : "");
+  cString buffer = cString::sprintf("%u:%s:%s:%04d:%04d:%d:%d:%s:%s\n", flags, UseChannelID ? *Channel()->GetChannelID().ToString() : *itoa(Channel()->Number()), *PrintDay(day, weekdays, true), start, stop, priority, lifetime, file, aux ? aux : "");
   strreplace(file, '|', ':');
-  return cString(buffer, true);
+  return buffer;
 }
 
 cString cTimer::ToDescr(void) const
 {
-  char *buffer;
-  asprintf(&buffer, "%d (%d %04d-%04d %s'%s')", Index() + 1, Channel()->Number(), start, stop, HasFlags(tfVps) ? "VPS " : "", file);
-  return cString(buffer, true);
+  return cString::sprintf("%d (%d %04d-%04d %s'%s')", Index() + 1, Channel()->Number(), start, stop, HasFlags(tfVps) ? "VPS " : "", file);
 }
 
 int cTimer::TimeToInt(int t)
@@ -287,6 +289,18 @@
         }
      //TODO add more plausibility checks
      result = ParseDay(daybuffer, day, weekdays);
+     if (VfatFileSystem) {
+        char *p = strrchr(filebuffer, '~');
+        if (p)
+           p++;
+        else
+           p = filebuffer;
+        if (strlen(p) > VFAT_MAX_FILENAME) {
+           dsyslog("timer file name too long for VFAT file system: '%s'", p);
+           p[VFAT_MAX_FILENAME] = 0;
+           dsyslog("timer file name truncated to '%s'", p);
+           }
+        }
      Utf8Strn0Cpy(file, filebuffer, MaxFileName);
      strreplace(file, '|', ':');
      if (isnumber(channelbuffer))
@@ -607,7 +621,7 @@
   Matches(); // refresh start and end time
 }
 
-// -- cTimers ----------------------------------------------------------------
+// --- cTimers ---------------------------------------------------------------
 
 cTimers Timers;
 
@@ -683,9 +697,28 @@
 
 void cTimers::SetModified(void)
 {
+  cStatus::MsgTimerChange(NULL, tcMod);
   state++;
 }
 
+void cTimers::Add(cTimer *Timer, cTimer *After)
+{
+  cConfig<cTimer>::Add(Timer, After);
+  cStatus::MsgTimerChange(Timer, tcAdd);
+}
+
+void cTimers::Ins(cTimer *Timer, cTimer *Before)
+{
+  cConfig<cTimer>::Ins(Timer, Before);
+  cStatus::MsgTimerChange(Timer, tcAdd);
+}
+
+void cTimers::Del(cTimer *Timer, bool DeleteObject)
+{
+  cStatus::MsgTimerChange(Timer, tcDel);
+  cConfig<cTimer>::Del(Timer, DeleteObject);
+}
+
 bool cTimers::Modified(int &State)
 {
   bool Result = state != State;
diff -ruN vdr-1.5.14/timers.h vdr-1.5.15/timers.h
--- vdr-1.5.14/timers.h	2007-06-03 15:24:58.000000000 +0200
+++ vdr-1.5.15/timers.h	2008-02-16 15:33:23.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.h 1.30 2007/06/03 13:24:58 kls Exp $
+ * $Id: timers.h 1.31 2008/02/16 14:33:23 kls Exp $
  */
 
 #ifndef __TIMERS_H
@@ -38,7 +38,7 @@
   int stop;
   int priority;
   int lifetime;
-  char file[MaxFileName];
+  mutable char file[MaxFileName];
   char *aux;
   const cEvent *event;
 public:
@@ -62,7 +62,7 @@
   const char *File(void) const { return file; }
   time_t FirstDay(void) const { return weekdays ? day : 0; }
   const char *Aux(void) const { return aux; }
-  cString ToText(bool UseChannelID = false);
+  cString ToText(bool UseChannelID = false) const;
   cString ToDescr(void) const;
   const cEvent *Event(void) const { return event; }
   bool Parse(const char *s);
@@ -119,6 +119,9 @@
       ///< Upon return the internal state will be stored in State.
   void SetEvents(void);
   void DeleteExpired(void);
+  void Add(cTimer *Timer, cTimer *After = NULL);
+  void Ins(cTimer *Timer, cTimer *Before = NULL);
+  void Del(cTimer *Timer, bool DeleteObject = true);
   };
 
 extern cTimers Timers;
diff -ruN vdr-1.5.14/tools.c vdr-1.5.15/tools.c
--- vdr-1.5.14/tools.c	2008-01-13 12:26:30.000000000 +0100
+++ vdr-1.5.15/tools.c	2008-02-16 14:38:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.140 2008/01/13 11:26:30 kls Exp $
+ * $Id: tools.c 1.143 2008/02/16 13:38:22 kls Exp $
  */
 
 #include "tools.h"
@@ -267,9 +267,7 @@
 
 cString AddDirectory(const char *DirName, const char *FileName)
 {
-  char *buf;
-  asprintf(&buf, "%s/%s", DirName && *DirName ? DirName : ".", FileName);
-  return cString(buf, true);
+  return cString::sprintf("%s/%s", DirName && *DirName ? DirName : ".", FileName);
 }
 
 cString itoa(int n)
@@ -279,6 +277,21 @@
   return buf;
 }
 
+bool EntriesOnSameFileSystem(const char *File1, const char *File2)
+{
+  struct statfs statFs;
+  if (statfs(File1, &statFs) == 0) {
+     fsid_t fsid1 = statFs.f_fsid;
+     if (statfs(File2, &statFs) == 0)
+        return memcmp(&statFs.f_fsid, &fsid1, sizeof(fsid1)) == 0;
+     else
+        LOG_ERROR_STR(File2);
+     }
+  else
+     LOG_ERROR_STR(File1);
+  return false;
+}
+
 int FreeDiskSpaceMB(const char *Directory, int *UsedMB)
 {
   if (UsedMB)
@@ -352,15 +365,14 @@
            struct dirent *e;
            while ((e = d.Next()) != NULL) {
                  if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-                    char *buffer;
-                    asprintf(&buffer, "%s/%s", FileName, e->d_name);
+                    cString buffer = AddDirectory(FileName, e->d_name);
                     if (FollowSymlinks) {
                        int size = strlen(buffer) * 2; // should be large enough
                        char *l = MALLOC(char, size);
                        int n = readlink(buffer, l, size);
                        if (n < 0) {
                           if (errno != EINVAL)
-                             LOG_ERROR_STR(buffer);
+                             LOG_ERROR_STR(*buffer);
                           }
                        else if (n < size) {
                           l[n] = 0;
@@ -372,10 +384,9 @@
                           esyslog("ERROR: symlink name length (%d) exceeded anticipated buffer size (%d)", n, size);
                        free(l);
                        }
-                    dsyslog("removing %s", buffer);
+                    dsyslog("removing %s", *buffer);
                     if (remove(buffer) < 0)
-                       LOG_ERROR_STR(buffer);
-                    free(buffer);
+                       LOG_ERROR_STR(*buffer);
                     }
                  }
            }
@@ -405,8 +416,7 @@
      struct dirent *e;
      while ((e = d.Next()) != NULL) {
            if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..") && strcmp(e->d_name, "lost+found")) {
-              char *buffer;
-              asprintf(&buffer, "%s/%s", DirName, e->d_name);
+              cString buffer = AddDirectory(DirName, e->d_name);
               struct stat st;
               if (stat(buffer, &st) == 0) {
                  if (S_ISDIR(st.st_mode)) {
@@ -417,10 +427,9 @@
                     empty = false;
                  }
               else {
-                 LOG_ERROR_STR(buffer);
+                 LOG_ERROR_STR(*buffer);
                  empty = false;
                  }
-              free(buffer);
               }
            }
      if (RemoveThis && empty) {
@@ -445,8 +454,7 @@
      struct dirent *e;
      while (size >= 0 && (e = d.Next()) != NULL) {
            if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-              char *buffer;
-              asprintf(&buffer, "%s/%s", DirName, e->d_name);
+              cString buffer = AddDirectory(DirName, e->d_name);
               struct stat st;
               if (stat(buffer, &st) == 0) {
                  if (S_ISDIR(st.st_mode)) {
@@ -460,10 +468,9 @@
                     size += st.st_size / MEGABYTE(1);
                  }
               else {
-                 LOG_ERROR_STR(buffer);
+                 LOG_ERROR_STR(*buffer);
                  size = -1;
                  }
-              free(buffer);
               }
            }
      return size;
@@ -489,13 +496,12 @@
 
 bool SpinUpDisk(const char *FileName)
 {
-  char *buf = NULL;
   for (int n = 0; n < 10; n++) {
-      free(buf);
+      cString buf;
       if (DirectoryOk(FileName))
-         asprintf(&buf, "%s/vdr-%06d", *FileName ? FileName : ".", n);
+         buf = cString::sprintf("%s/vdr-%06d", *FileName ? FileName : ".", n);
       else
-         asprintf(&buf, "%s.vdr-%06d", FileName, n);
+         buf = cString::sprintf("%s.vdr-%06d", FileName, n);
       if (access(buf, F_OK) != 0) { // the file does not exist
          timeval tp1, tp2;
          gettimeofday(&tp1, NULL);
@@ -503,21 +509,19 @@
          // O_SYNC doesn't work on all file systems
          if (f >= 0) {
             if (fdatasync(f) < 0)
-               LOG_ERROR_STR(buf);
+               LOG_ERROR_STR(*buf);
             close(f);
             remove(buf);
             gettimeofday(&tp2, NULL);
             double seconds = (((long long)tp2.tv_sec * 1000000 + tp2.tv_usec) - ((long long)tp1.tv_sec * 1000000 + tp1.tv_usec)) / 1000000.0;
             if (seconds > 0.5)
                dsyslog("SpinUpDisk took %.2f seconds", seconds);
-            free(buf);
             return true;
             }
          else
-            LOG_ERROR_STR(buf);
+            LOG_ERROR_STR(*buf);
          }
       }
-  free(buf);
   esyslog("ERROR: SpinUpDisk failed");
   return false;
 }
@@ -888,7 +892,21 @@
   va_list ap;
   va_start(ap, fmt);
   char *buffer;
-  vasprintf(&buffer, fmt, ap);
+  if (!fmt || vasprintf(&buffer, fmt, ap) < 0) {
+     esyslog("error in vasprintf('%s', ...)", fmt);
+     buffer = strdup("???");
+     }
+  va_end(ap);
+  return cString(buffer, true);
+}
+
+cString cString::sprintf(const char *fmt, va_list &ap)
+{
+  char *buffer;
+  if (!fmt || vasprintf(&buffer, fmt, ap) < 0) {
+     esyslog("error in vasprintf('%s', ...)", fmt);
+     buffer = strdup("???");
+     }
   return cString(buffer, true);
 }
 
@@ -1241,8 +1259,8 @@
               if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
                  if (DirsOnly) {
                     struct stat ds;
-                    if (stat(e->d_name, &ds) == 0) {
-                       if (S_ISDIR(ds.st_mode))
+                    if (stat(AddDirectory(Directory, e->d_name), &ds) == 0) {
+                       if (!S_ISDIR(ds.st_mode))
                           continue;
                        }
                     }
@@ -1622,7 +1640,7 @@
   fileName = NULL;
   f = -1;
   if (DirectoryOk(Directory))
-     asprintf(&fileName, "%s/%s", Directory, LOCKFILENAME);
+     fileName = strdup(AddDirectory(Directory, LOCKFILENAME));
 }
 
 cLockFile::~cLockFile()
diff -ruN vdr-1.5.14/tools.h vdr-1.5.15/tools.h
--- vdr-1.5.14/tools.h	2008-01-13 12:22:26.000000000 +0100
+++ vdr-1.5.15/tools.h	2008-02-17 14:41:27.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.110 2008/01/13 11:22:26 kls Exp $
+ * $Id: tools.h 1.113 2008/02/17 13:41:27 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -156,11 +156,13 @@
   cString(const char *S = NULL, bool TakePointer = false);
   cString(const cString &String);
   virtual ~cString();
+  operator const void * () const { return s; } // to catch cases where operator*() should be used
   operator const char * () const { return s; } // for use in (const char *) context
   const char * operator*() const { return s; } // for use in (const void *) context (printf() etc.)
   cString &operator=(const cString &String);
   cString &Truncate(int Index); ///< Truncate the string at the given Index (if Index is < 0 it is counted from the end of the string).
   static cString sprintf(const char *fmt, ...) __attribute__ ((format (printf, 1, 2)));
+  static cString sprintf(const char *fmt, va_list &ap);
   };
 
 ssize_t safe_read(int filedes, void *buffer, size_t size);
@@ -192,6 +194,7 @@
 bool isnumber(const char *s);
 cString itoa(int n);
 cString AddDirectory(const char *DirName, const char *FileName);
+bool EntriesOnSameFileSystem(const char *File1, const char *File2);
 int FreeDiskSpaceMB(const char *Directory, int *UsedMB = NULL);
 bool DirectoryOk(const char *DirName, bool LogErrors = false);
 bool MakeDirs(const char *FileName, bool IsDirectory = false);
diff -ruN vdr-1.5.14/vdr.c vdr-1.5.15/vdr.c
--- vdr-1.5.14/vdr.c	2008-01-27 15:38:45.000000000 +0100
+++ vdr-1.5.15/vdr.c	2008-02-10 15:23:31.000000000 +0100
@@ -1,7 +1,7 @@
 /*
  * vdr.c: Video Disk Recorder main program
  *
- * Copyright (C) 2000, 2003, 2006 Klaus Schmidinger
+ * Copyright (C) 2000, 2003, 2006, 2008 Klaus Schmidinger
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.307 2008/01/27 14:38:45 kls Exp $
+ * $Id: vdr.c 1.310 2008/02/10 14:23:31 kls Exp $
  */
 
 #include <getopt.h>
@@ -86,7 +86,7 @@
 
 static int LastSignal = 0;
 
-static bool SetUser(const char *UserName)
+static bool SetUser(const char *UserName, bool UserDump)//XXX name?
 {
   if (UserName) {
      struct passwd *user = getpwnam(UserName);
@@ -106,10 +106,8 @@
         fprintf(stderr, "vdr: cannot set user id %u: %s\n", (unsigned int)user->pw_uid, strerror(errno));
         return false;
         }
-     if (prctl(PR_SET_DUMPABLE, 2, 0, 0, 0) < 0) {
+     if (UserDump && prctl(PR_SET_DUMPABLE, 1, 0, 0, 0) < 0)
         fprintf(stderr, "vdr: warning - cannot set dumpable: %s\n", strerror(errno));
-        // always non-fatal, and will not work with kernel < 2.6.13
-        }
      }
   return true;
 }
@@ -187,6 +185,7 @@
 
   bool StartedAsRoot = false;
   const char *VdrUser = NULL;
+  bool UserDump = false;
   int SVDRPport = DEFAULTSVDRPPORT;
   const char *AudioCommand = NULL;
   const char *ConfigDirectory = NULL;
@@ -241,6 +240,7 @@
       { "shutdown", required_argument, NULL, 's' },
       { "terminal", required_argument, NULL, 't' },
       { "user",     required_argument, NULL, 'u' },
+      { "userdump", no_argument,       NULL, 'u' | 0x100 },
       { "version",  no_argument,       NULL, 'V' },
       { "vfat",     no_argument,       NULL, 'v' | 0x100 },
       { "video",    required_argument, NULL, 'v' },
@@ -346,6 +346,9 @@
           case 'u': if (*optarg)
                        VdrUser = optarg;
                     break;
+          case 'u' | 0x100:
+                    UserDump = true;
+                    break;
           case 'V': DisplayVersion = true;
                     break;
           case 'v' | 0x100:
@@ -376,7 +379,7 @@
      if (strcmp(VdrUser, "root")) {
         if (!SetKeepCaps(true))
            return 2;
-        if (!SetUser(VdrUser))
+        if (!SetUser(VdrUser, UserDump))
            return 2;
         if (!SetKeepCaps(false))
            return 2;
@@ -431,6 +434,7 @@
                "  -t TTY,   --terminal=TTY controlling tty\n"
                "  -u USER,  --user=USER    run as user USER; only applicable if started as\n"
                "                           root\n"
+               "            --userdump     allow coredumps if -u is given (debugging)\n"
                "  -v DIR,   --video=DIR    use DIR as video directory (default: %s)\n"
                "  -V,       --version      print version information and exit\n"
                "            --vfat         encode special characters in recording names to\n"
@@ -874,7 +878,7 @@
                         if (cDevice::PrimaryDevice()->HasDecoder() && !cDevice::PrimaryDevice()->HasProgramme()) {
                            // the previous SwitchChannel() has switched away the current live channel
                            Channels.SwitchTo(Timer->Channel()->Number()); // avoids toggling between old channel and black screen
-                           Skins.Message(mtInfo, tr("Upcoming VPS recording!"));
+                           Skins.Message(mtInfo, tr("Upcoming recording!"));
                            }
                         }
                      }
diff -ruN vdr-1.5.14/videodir.c vdr-1.5.15/videodir.c
--- vdr-1.5.14/videodir.c	2005-12-18 11:33:20.000000000 +0100
+++ vdr-1.5.15/videodir.c	2008-02-16 14:00:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: videodir.c 1.14 2005/12/18 10:33:20 kls Exp $
+ * $Id: videodir.c 1.15 2008/02/16 13:00:03 kls Exp $
  */
 
 #include "videodir.h"
@@ -232,3 +232,12 @@
      } while (Dir.Next());
 }
 
+bool IsOnVideoDirectoryFileSystem(const char *FileName)
+{
+  cVideoDirectory Dir;
+  do {
+     if (EntriesOnSameFileSystem(Dir.Name(), FileName))
+        return true;
+     } while (Dir.Next());
+  return false;
+}
diff -ruN vdr-1.5.14/videodir.h vdr-1.5.15/videodir.h
--- vdr-1.5.14/videodir.h	2005-10-31 12:50:23.000000000 +0100
+++ vdr-1.5.15/videodir.h	2008-02-16 13:53:11.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: videodir.h 1.6 2005/10/31 11:50:23 kls Exp $
+ * $Id: videodir.h 1.7 2008/02/16 12:53:11 kls Exp $
  */
 
 #ifndef __VIDEODIR_H
@@ -23,5 +23,6 @@
 int VideoDiskSpace(int *FreeMB = NULL, int *UsedMB = NULL); // returns the used disk space in percent
 cString PrefixVideoFileName(const char *FileName, char Prefix);
 void RemoveEmptyVideoDirectories(void);
+bool IsOnVideoDirectoryFileSystem(const char *FileName);
 
 #endif //__VIDEODIR_H
